Attribute VB_Name = "modMinMax"
Option Explicit

Private WinOldProcMinMax

Private Const GWL_WNDPROC = (-4)
Private Const WM_GETMINMAXINFO = &H24
Private lX1 As Long, lX2 As Long, lY1 As Long, lY2 As Long

Private Type POINTAPI
    x As Long
    y As Long
End Type

Private Type MINMAXINFO
    ptReserved As POINTAPI
    ptMaxSize As POINTAPI
    ptMaxPosition As POINTAPI
    ptMinTrackSize As POINTAPI  ' Minimale Grsse
    ptMaxTrackSize As POINTAPI  ' Maximale Grsse
End Type

Private Declare Function DefWindowProc Lib "user32" Alias "DefWindowProcA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Sub CopyMemory1 Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private Declare Sub CopyMemory2 Lib "kernel32" Alias "RtlMoveMemory" (ByVal Destination As Any, Source As Any, ByVal Length As Long)

Public Sub SetMinMax(Form As Form, x1 As Long, y1 As Long, x2 As Long, y2 As Long)
    WinOldProcMinMax = SetWindowLong(Form.hWnd, GWL_WNDPROC, AddressOf WindowProcMinMax)
    lX1 = x1
    lX2 = x2
    lY1 = y1
    lY2 = y2
End Sub

Public Sub UnloadMinMax(Form As Form)
    SetWindowLong Form.hWnd, GWL_WNDPROC, WinOldProcMinMax
End Sub

Private Function WindowProcMinMax(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim ret&
    
    If uMsg = WM_GETMINMAXINFO Then
        Dim MM As MINMAXINFO
        CopyMemory1 MM, lParam, Len(MM)
        MM.ptMinTrackSize.x = lX1
        MM.ptMinTrackSize.y = lY1
        MM.ptMaxTrackSize.x = lX2
        MM.ptMaxTrackSize.y = lY2
        CopyMemory2 lParam&, MM, Len(MM)
        ret& = DefWindowProc(hWnd, uMsg, wParam, lParam)
    Else    ' Wenn andere Nachricht, dann 'Durchlassen'.
        ret& = CallWindowProc(WinOldProcMinMax, hWnd, uMsg, wParam, lParam)
    End If
    
    WindowProcMinMax = ret
End Function
